# Название:     Folder
# Сайт:            http://stroyka.in 
# Дата:            14.03.2011
# Обнавлён:     27.12.2012
# Автор:          Sahi (г.Рязань)
# Описание:    папки на всякий случай
#  Sahi::Encode.encode_to_utf8(string)
#  Sahi::Encode.encode_to_cp1251(string)
#=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=#
module Sahi
                     
module Folder
  
   mydir,name = File.split(__FILE__)
   mydir = File.expand_path(mydir)
   mydir = Sahi::Encode.encode_to_utf8(mydir)
   mydirfile = mydir + "/images/folder.dat"
   namedir = mydirfile.tr("\\","/")
   @@namefile =namedir.freeze
   
def self.open_model
   
   sell = Array.new
   sell=IO.readlines(@@namefile)

   if(sell[0] != nil)
       newfolder=sell[0].strip.split("#")
       string =File.expand_path(newfolder.last) rescue string = ""
       string = Sahi::Encode.encode_to_cp1251(string) unless(File.directory?(string))
       string = "" unless(File.directory?(string))
      else
       string = ""
     end
     
   string = string.tr("/","\\") + "\\" rescue string = ""
   file_open = UI.openpanel("Open model SketchUp ","#{string}", "*.skp")

   if(file_open)
     Sketchup.open_file file_open
     Sketchup.active_model.commit_operation
     mydir,name = File.split(file_open)
     sell[0] = "#"+ mydir.to_s + "\n"
   end
   gfile = File.new(@@namefile, "wb+")
   sell.each{|str| gfile.write str}
   gfile.close
 end

# -------             # -------               # -------
 def self.import_model

   sell = Array.new
   sell=IO.readlines(@@namefile)

   if(sell[1] != nil)
     newfolder=sell[1].strip.split("#")
     string =File.expand_path(newfolder.last) rescue string = ""
     string = Sahi::Encode.encode_to_cp1251(string) unless(File.directory?(string))
     string = "" unless(File.directory?(string))
    else
      string = ""
   end
    
    string = string.tr("/","\\") + "\\" rescue string = ""
    file_imp = UI.openpanel("Import model SketchUp","#{string}","*.skp") 
    
   if(file_imp)
     comp = Sketchup.active_model.definitions.load(file_imp)
     Sketchup.active_model.place_component comp, false
     Sketchup.active_model.commit_operation
     mydir,name = File.split(file_imp)
     sell[0] = "#\n" if not (sell[0])
     sell[1] = "#"+ mydir.to_s + "\n"
   end
   gfile = File.new(@@namefile, "wb+")
   sell.each{|str| gfile.write str}
   gfile.close
 end
 
# -------             # -------               # -------
def self.save_model

   # options_manager = Sketchup.active_model.options['UnitsOptions']
   # options_manager["LengthFormat"["LengthFormat"]] = 0
   # options_manager['LengthUnit'['LengthUnit']] = 3   # 4 = метры <> 3 = сантиметры <> 2 = миллиметры
   path = Sketchup.active_model.path
   if(!path or path != "" )
     file_name = path
      begin
       myname = File.basename(file_name)
       Sketchup.active_model.save(file_name, Sketchup::Model::VERSION_8)
       UI.messagebox("Save in SketchUp 8  as #{myname}")  rescue UI.messagebox("Error saving")
      rescue
        version = Sketchup.version.to_i
        Sketchup.send_action(57603)  # сохранить модель
        UI.messagebox("Save in SketchUp #{version} as #{myname}") rescue UI.messagebox("Error saving")
      end
     else
       Sketchup.send_action(57604) # сохранить модель как
   end
   Sketchup.active_model.commit_operation
 end
# :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< #
# -------             # -------               # -------
# :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< #
 if( not file_loaded?(__FILE__))
   sahi_toolbar_tools = UI::Toolbar.new("Folder")
   #$sahi_toolbar_tools.add_separator
   cmd1 = UI::Command.new("Open"){open_model}
   cmd1.large_icon = "./images/open.png"
   cmd1.small_icon = "./images/open.png"
   cmd1.tooltip = "Open model SketchUp"
   cmd1.status_bar_text = "Open the folder to open a model SketchUp"
   sahi_toolbar_tools.add_item(cmd1)

   cmd2 = UI::Command.new("import"){import_model}
   cmd2.large_icon = "./images/import.png"
   cmd2.small_icon = "./images/import.png"
   cmd2.tooltip = "Import model SketchUp"
   cmd2.status_bar_text = "Open the folder and import model SketchUp"
   sahi_toolbar_tools.add_item(cmd2)

   cmd3 = UI::Command.new("save_5"){save_model}
   cmd3.large_icon = "./images/save_5.png"
   cmd3.small_icon = "./images/save_5.png"
   cmd3.tooltip = "Save model in SketchUp 8"
   cmd3.status_bar_text = "Save the model in version 8 SketchUp"
   sahi_toolbar_tools.add_item(cmd3)
   sahi_toolbar_tools.show
   #$sahi_toolbar_tools.add_separator
  end
# :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< #
end # Folder
# :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< #
end # Sahi
# :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< #
#=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=#                         
                          